﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Логика взаимодействия для ShowPage.xaml
    /// </summary>
    public partial class ShowPage : Page
    {
        public ShowPage()
        {
            InitializeComponent();
            lvMaterials.ItemsSource = BaseClass.baseDate.Material.ToList();
            List<MaterialType> materialTypes = BaseClass.baseDate.MaterialType.ToList();
            cbFilt.Items.Add("Все типы");
            foreach (MaterialType materialType in materialTypes)
            {
                cbFilt.Items.Add(materialType.Title);
            }
            cbFilt.SelectedIndex = 0;
            cbSort.SelectedIndex = 0;
            CountMaterial.Text = BaseClass.baseDate.Material.ToList().Count + " из " + BaseClass.baseDate.Material.ToList().Count;
        }

        private void Filter()
        {
            List<Material> materials = BaseClass.baseDate.Material.ToList();
            if(tbSearch.Text.Length > 0)
            {
                materials = materials.Where(x => x.Title.ToLower().Contains(tbSearch.Text.ToLower())).ToList();
                List<Material> materials1 = BaseClass.baseDate.Material.Where(x => x.Description.ToLower().Contains(tbSearch.Text.ToLower())).ToList();
                foreach(Material material in materials1)
                {
                    materials.Add(material);
                }
                materials = materials.Distinct().ToList();
            }
            if(cbFilt.SelectedIndex != 0)
            {
                materials = materials.Where(x => x.MaterialType.Title == cbFilt.SelectedValue).ToList();
            }
            switch(cbSort.SelectedIndex)
            {
                case 1:
                    materials = materials.OrderBy(x => x.Title).ToList();
                    break;
                case 2:
                    materials = materials.OrderByDescending(x => x.Title).ToList();
                    break;
                case 3:
                    materials = materials.OrderBy(x => x.CountinStock).ToList();
                    break;
                case 4:
                    materials = materials.OrderByDescending(x => x.CountinStock).ToList();
                    break;
                case 5:
                    materials = materials.OrderBy(x => x.Cost).ToList();
                    break;
                case 6:
                    materials = materials.OrderByDescending(x => x.Cost).ToList();
                    break;
            }
            lvMaterials.ItemsSource = materials;
            if(materials.Count == 0)
            {
                MessageBox.Show("Данные удовлетворяющие параметрам отсутствуют");
            }
            CountMaterial.Text = materials.Count.ToString() + " из " + BaseClass.baseDate.Material.Count();
        }

        private void cbSort_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void tbSearch_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void BtnDelete_Click(object sender, RoutedEventArgs e)
        {
            Button button = (Button)sender;
            int index = Convert.ToInt32(button.Uid);
            try
            {
                if(MessageBox.Show("Вы уверены что хотите удалить?", "Системное сообщение", MessageBoxButton.YesNo, MessageBoxImage.Warning) == MessageBoxResult.Yes)
                {
                    Material material = BaseClass.baseDate.Material.FirstOrDefault(x => x.ID == index);
                    BaseClass.baseDate.Material.Remove(material);
                    BaseClass.baseDate.SaveChanges();
                    ClassFrame.frame.Navigate(new ShowPage());
                }
            }
            catch
            {
                MessageBox.Show("При удаление возникла ошибка");
            }
        }

        private void BtnUpdate_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            int index = Convert.ToInt32(button.Uid);
            ClassFrame.frame.Navigate(new UpdMaterial(index));
        }

        private void BtnAdd_Click(object sender, RoutedEventArgs e)
        {
            ClassFrame.frame.Navigate(new UpdMaterial());
        }
    }
}
