﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Логика взаимодействия для UpdMaterial.xaml
    /// </summary>
    public partial class UpdMaterial : Page
    {
        Material material;
        public UpdMaterial(int index)
        {
            InitializeComponent();
            Material material1 = BaseClass.baseDate.Material.FirstOrDefault(x => x.ID == index);
            material = material1;
            CompletionField();
            TBHeader.Text = "Изменение материала";
            BtnAddUpd.Content = "Изменить";

            TBTitle.Text = material.Title;
            CountInPack.Text = material.CountInPack.ToString();
            TBUnit.Text = material.Unit;
            TBMinCount.Text = material.MinCount.ToString();
            TBCost.Text = material.Cost.ToString();
            TBDescription.Text = material.Description;
            CBType.SelectedValue = material.MaterialTypeId;
            if(material.Image != null)
            {
                Image.Source = new BitmapImage(new Uri("" + material.Image, UriKind.Relative));
            }
            else
            {
                Image.Source = new BitmapImage(new Uri("/resources/picture.png", UriKind.Relative));
            }
        }

        public UpdMaterial()
        {
            InitializeComponent();
            CompletionField();
            TBHeader.Text = "Добавление материала";
            BtnAddUpd.Content = "Добавить";
            Image.Source = new BitmapImage(new Uri("/resources/picture.png", UriKind.Relative));

        }

        private void CompletionField()
        {
            CBType.ItemsSource = BaseClass.baseDate.MaterialType.ToList();
            CBType.SelectedValuePath = "ID";
            CBType.DisplayMemberPath = "Title";
        }

        private void BtnBack_Click(object sender, RoutedEventArgs e)
        {
            ClassFrame.frame.Navigate(new ShowPage());
        }

        private void TextBox_PreviewTextInput(object sender, TextCompositionEventArgs e)
        {
            if(!(Char.IsDigit(e.Text, 0)))
            {
                e.Handled = true;
            }
        }

        private void BtnAddUpd_Click(object sender, RoutedEventArgs e)
        {
            
        }

        private void UpdImage_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                string path;
                OpenFileDialog OFD = new OpenFileDialog();
                OFD.ShowDialog();
                path = OFD.SafeFileName;
                if (path != null)
                {
                    string newPath = "/materials/" + path;
                    Image.Source = new BitmapImage(new Uri(newPath, UriKind.Relative));
                }
            }
            catch
            {
                MessageBox.Show("При добавлении нового фото возникла ошибка!");
            }
        }
    }
}
